# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import pulumi
import pulumi.runtime
from . import utilities, tables

class Project(pulumi.CustomResource):
    created: pulumi.Output[str]
    """
    The timestamp for when the Project was created
    """
    name: pulumi.Output[str]
    """
    The name of the Project on Packet.net
    """
    organization_id: pulumi.Output[str]
    """
    The UUID of Organization under which you want to create the project. If you leave it out, the project will be create under your the default Organization of your account.
    """
    payment_method_id: pulumi.Output[str]
    """
    The UUID of payment method for this project. If you keep it empty, Packet API will pick your default Payment Method.
    """
    updated: pulumi.Output[str]
    """
    The timestamp for the last time the Project was updated
    """
    def __init__(__self__, __name__, __opts__=None, name=None, organization_id=None, payment_method_id=None):
        """
        Provides a Packet Project resource to allow you manage devices
        in your projects.
        
        
        :param str __name__: The name of the resource.
        :param pulumi.ResourceOptions __opts__: Options for the resource.
        :param pulumi.Input[str] name: The name of the Project on Packet.net
        :param pulumi.Input[str] organization_id: The UUID of Organization under which you want to create the project. If you leave it out, the project will be create under your the default Organization of your account.
        :param pulumi.Input[str] payment_method_id: The UUID of payment method for this project. If you keep it empty, Packet API will pick your default Payment Method.
        """
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, str):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if not name:
            raise TypeError('Missing required property name')
        __props__['name'] = name

        __props__['organization_id'] = organization_id

        __props__['payment_method_id'] = payment_method_id

        __props__['created'] = None
        __props__['updated'] = None

        super(Project, __self__).__init__(
            'packet:index/project:Project',
            __name__,
            __props__,
            __opts__)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

